<?php
	// Get the curl handle
	$ch = curl_init();
	
	// Retrieving data from the url
    curl_setopt($ch, CURLOPT_URL, "http://news.cnet.com/8300-17938_105-1.xml?tag=rtcol;about");
    
    // Return the data back as string in curl_exec
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    
    // Set the timeout for the curl
    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 400);
    
    // Execute the curl
    $response = curl_exec($ch);
    
    if(curl_errno($ch)) {
    	print "<html> <body>";
		print "<h1>Curl error: " . curl_error($ch) . "</h1>";
	    print "</body> </html>";
    	exit;
    }
    
    // Use XML parser
    $xml = simplexml_load_string($response, null, LIBXML_NOWARNING);
    
    if (is_object($xml) == false) {
    	print "<html> <body>";
		print "<h1>Invalid XML Data</h1>";
	    print "</body> </html>";
	    exit;
	}
    
	print "<html> <body>";
	print "<h1>" . trim($xml->channel->title) . "</h1>";
    parseXML($xml);
    print "</body> </html>";
    
    function parseXML($xml) {
     	$items = $xml->channel->item;
    	foreach ($items as $item) {
    		print "<ul>";
    		print "<li><font size=4><a href=\"" . trim($item->link) . "\">" .trim($item->title) . "</a></font></li>";
    		print "<ul>";
    		print "<li><font color=\"gray\">" . trim($item->description) . "</font></li>";
    		print "</ul>";
    		print "</ul>";
    	}
    }
	
?>