<?php

include_once('Masters Project/Constants.php');
include_once('Masters Project/OneSocial.php');


class Facebook extends OneSocial {
	
	const API_KEY   = "63f06c85f8715fed9d738fb089669810";
 	const SECRET    = "054f58f72a5edb4ac561e4d121ace953";
	const CLIENT_ID = "362821452503";
	
	public function getSession($user, $args) {
		$sessionData = parent::getSessionFromDB($user, Constants::FACEBOOK_APP_ID);
		if (!empty($sessionData['secret'])) {
			return $sessionData;
		}
		
		if (!empty($args['code'])) {
			$out = $this->getAccessToken($args['code']);
			list ($key, $accessToken) = split("=", $out);
			parent::insertSessionIntoDB($user, Constants::FACEBOOK_APP_ID, null, $accessToken);
		    return array('token' => null, 'secret' => $accessToken);
		} else {
			return $sessionData;
		}
	}
	
	public function getFriends($secret, $authToken) {
		$ch = curl_init();

		curl_setopt($ch, CURLOPT_URL, "https://graph.facebook.com/me/friends?access_token=$secret");
	    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 10000);
	
	    $out  = curl_exec($ch);
	    $data = json_decode($out, true);
	    
	    // Get Facebook Friends
	    $friends = $data["data"];
	    
		return $friends;
	}
	
	public function addFriends() {
		return true;
	}
	
	public function validateSession() {
		return true;
	}	
	
	public function getUpdates($secret, $authToken, $recentMsg) {

		$ch = curl_init();

		curl_setopt($ch, CURLOPT_URL, "https://graph.facebook.com/me/home?access_token=$secret");
	    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 10000);
	
	    $out  = curl_exec($ch);
	    $info = curl_getinfo($ch);

	    // Likely that there is something wrong with the session
	    if ($info['http_code'] != 200) {
	    	return false;
	    }
	
	    $data   = json_decode($out, true);
		$stream = $data['data'];

	    $oneSocialResonse = array();
	    
	    foreach ($stream as $msg) {
	    	if ($msg['type'] != 'status') {
	    		continue;
	    	}
	    	
	    	$oneResponse = array();
	    	$createdTime = $msg['created_time'];
	    	$oneResponse['attribution'] = $attribution = @$msg['attribution'];
	    	$oneResponse['likes']       = $likes       = @$msg['likes'];
	    	
	    	
	    	$image = '';
	    	if (empty($msg['from']['id'])) {
	    	} else {
	    		$image = "https://graph.facebook.com/{$msg['from']['id']}/picture";
	    	}
	    	
	    	$oneResponse['app']   = Constants::FACEBOOK_APP_ID;
	    	$oneResponse['image'] = $image;
	    	$oneResponse['user']  = $msg['from']['name'];
	    	$oneResponse['text']  = $msg['message'];
	    	$oneResponse['id']    = $msg['id'];
	    	
	    	$time = $this->determineTimeAgo(strtotime($msg['created_time']));
	    	if (is_array($time)) {
	    	}
	    	$oneResponse['time'] = $time;
	    	
			
	    	$index = 0;
	    	if (isset($msg['comments']['data']) && is_array($msg['comments']['data'])) {
		    	foreach ($msg['comments']['data'] as $comment) {
		    		
		    		$image = '';
			    	if (empty($msg['from']['id'])) {
		    		} else {
		    			$image = "https://graph.facebook.com/{$comment['from']['id']}/picture";
		    		}
		    		$time = $this->determineTimeAgo(strtotime($comment['created_time']));
		    		
		    		$oneResponse['message'][$index]['image'] = $image;
		    		$oneResponse['message'][$index]['text']  = $comment['message'];
		    		$oneResponse['message'][$index]['user']  = $comment['from']['name'];
		    		$oneResponse['message'][$index]['app']   = Constants::FACEBOOK_APP_ID;
		    		$oneResponse['message'][$index]['time']  = $time;
		    		$index++;
		    		
		    	}
	    	}
	    	
	    	$oneSocialResponse[$oneResponse['time'][Constants::SECONDS] . 'f'][] = $oneResponse;
	    }
	    
	    return $oneSocialResponse;
	}
	
	public function setUpdates($authSecret, $authToken, $status) {
		$xPost['access_token'] = $authSecret;
		$xPost['message'] 	   = $status;
	
		$ch = curl_init();
	    curl_setopt($ch, CURLOPT_URL, "https://graph.facebook.com/me/feed");
	    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $xPost);
	    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
	
	    curl_exec($ch);	
	}
	
	public function setComments($authSecret, $authToken, $comment, $statusID) {
		$xPost['access_token'] = $authSecret;
		$xPost['message'] 	   = $comment;
	
		$ch = curl_init();
	    curl_setopt($ch, CURLOPT_URL, "https://graph.facebook.com/$statusID/comments");
	    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $xPost);
	    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
	
	    curl_exec($ch);
	}
	
	public function showLoginURL($auth) {
	    print "<h3>View Your Facebook Activity from One Social</h3>";
	    print "<a href='https://graph.facebook.com/oauth/authorize?client_id=" . self::CLIENT_ID . 
	    	  "&redirect_uri=" . Constants::WEB_URL . "callback.php&scope=publish_stream,offline_access'><img border=0 src=\"" . Constants::WEB_URL . "/images/connectfacebook.gif\"></a><br/>";
	}
	
	public function getRequestToken() {
		return true;
	}
	
	public function getAccessToken($reqAuthToken) {
		
		$url  = "https://graph.facebook.com/oauth/access_token?client_id=" . 
		       		self::CLIENT_ID . "&redirect_uri=" . Constants::WEB_URL . "callback.php&client_secret=" . 
		       		self::SECRET . "&code=$reqAuthToken";
	
		$ch  = curl_init();
		
	    curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	
		$out  = curl_exec($ch);
		$info = curl_getinfo($ch);

	    // Likely that there is something wrong with the session
	    if ($info['http_code'] != 200) {
	    	return false;
	    }
	    
		return $out;
	}
}

?>