<?php

// Get multi curls from cnet.com

$urls = array (
			'http://news.cnet.com/8300-17938_105-1.xml?tag=rtcol;about',
			'http://reviews.cnet.com/4924-3000_7-0.xml?orderBy=-7rvDte&7rType=70-80&maxhits=10&tag=rb_content;rb_mtx',
			'http://reviews.cnet.com/4924-3243_7-0.xml?orderBy=-7rvDte&7rType=70-80&maxhits=10&tag=rb_content;rb_mtx',
			'http://news.cnet.com/8300-17938_105-1.xml?tag=rtcol;about'
		);
$count = count($urls);
		
// Create multi handle and add individual handles to it
$ch = array();
$mh = curl_multi_init();
for ($i = 0; $i < $count; $i++) {
	$ch[$i] = curl_init(); 
	curl_setopt($ch[$i], CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch[$i], CURLOPT_URL, $urls[$i]);
	curl_multi_add_handle($mh, $ch[$i]);
}

// Execute multi curl
$running=null;
do {
    curl_multi_exec($mh, $running);
} while ($running > 0);
 
print "<script type=\"text/javascript\">
	    function toggle_visibility(id) {
	       var e = document.getElementById(id);
	       if(e.style.display == 'block')
	          e.style.display = 'none';
	       else
	          e.style.display = 'block';
	    }
	</script>";

// Get the data for all the urls
$data = array();
print "<html>";
for ($i = 0; $i < $count; $i++) {
	$data[$i] = curl_multi_getcontent($ch[$i]);
	$obj = simplexml_load_string($data[$i]);
	print "<html><body>";
	print "<a href=\"#\" onclick=\"toggle_visibility('" . $i . "');\"> " . $obj->channel->title . " </a></br></br>";
	parseXML($obj, $i);
	print "</body></html>";
	curl_multi_remove_handle($mh, $ch[$i]);
}
print "</html>";

curl_multi_close($mh);

function parseXML($xml, $x) {

    print "<div style=\"display:none\" id=\"" . $x . "\">";
    
    $items = $xml->channel->item;
    foreach ($items as $item) {
   		print "<ul>";
   		print "<li><font size=4><a href=\"" . trim($item->link) . "\">" .trim($item->title) . "</a></font></li>";
   		print "<ul>";
   		print "<li><font color=\"gray\">" . trim($item->description) . "</font></li>";
   		print "</ul>";
   		print "</ul>";
    }
    print "</div>";
    
}

?>