<?php

abstract class OneSocial {
	
	abstract protected function getSession($userID, $args);
	
	abstract protected function getAccessToken($reqAuthToken);
	
	abstract protected function getFriends($authSecret, $authToken);
	
	abstract protected function addFriends();
	
	abstract protected function validateSession();
	
	abstract protected function getUpdates($authSecret, $authToken, $recentMsg);
	
	abstract protected function setUpdates($authSecret, $authToken, $status);
	
	abstract protected function setComments($authSecret, $authToken, $comment, $statusID);
	
	abstract protected function showLoginURL($auth);
	
	public function getSessionFromDB($userID, $appID) {

		$session_id = false;
		$auth_token = false;
		mysql_connect('localhost', 'sowmya', 'sowmya');
		
		$query   = "SELECT auth_token, session_id FROM onesocial.sessions where user_id='$userID' and app_id=$appID";
		$result  = mysql_query($query);
		$numRows = mysql_numrows($result);
		
		for ($i = 0; $i < $numRows; $i++) {
			$session_id = mysql_result($result, $i, "session_id");
			$auth_token = mysql_result($result, $i, "auth_token");
			
		}
		
		return array ('secret' => $session_id, 'token' => $auth_token);
	}
	
	public function insertSessionIntoDB($user_id, $app_id, $req_auth_token, $session_id) {
		mysql_connect('localhost', 'sowmya', 'sowmya');
		
		$query   = "INSERT INTO onesocial.sessions VALUES ('$user_id', $app_id, '$req_auth_token', '$session_id')";
		$result  = mysql_query($query);
	}
	
	public function removeSessionFromDB($userID, $app_id) {
		mysql_connect('localhost', 'sowmya', 'sowmya');
		
		$query   = "DELETE FROM onesocial.sessions WHERE user_id='$userID' AND app_id=$app_id";
		$result  = mysql_query($query);
	}
	
	public function startLayoutHTML() {

		$html = <<<HTML
<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'> 
<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en'>
<head>
<meta http-equiv='content-type' content='application/xhtml+xml; charset=utf-8' />
<title>One Social</title>
<link rel='stylesheet' type='text/css' href='onesocial.css' />
</head>
<body>
<div id='container'>
	<div id='header'>	
		<h1><span>ONE</span>SOCIAL</h1>
		<!-- ### Top Menu ### -->
		<div id='topmenu'>
		<ul>
			<li><a href='#'>Home</a></li>	
			<li><a href='Main.php?logoff=1'>Logoff</a></li>	
		</ul>	
		</div>
	</div>
	<div id='contentcontainer'>
		<div id='content'>
HTML;
	    print $html;
	}
	
	public function friendsLayoutHTML($fbFriends=0, $twFriends=0) {
		$html = <<<HTML
				<!-- ### Post Entry Begin ###  -->
			<div class='post'>
				<div id="bodyright">
					<div id="sidebar"> 
						<ul> 
				 
						<li class="linkcat"><h2>Friends</h2> 
						<ul> 
							<li>{$fbFriends} Facebook Friends</li> 
							<li>{$twFriends} Twitter Following</li>  
						</ul> 
						</li> 
						</li> 
				 
						</ul>	
						
					 </div> 
											
				</div>
			</div>
			<div id="bodyleft">
HTML;
		print $html;
	}
	
	public function endLayoutHTML() {
		$html = <<<HTML
		</div>

		      </div>
			<!-- ### Post Entry End ### -->
			</div>
		</div>
	</div>
<div id='content2'>
	<p> 
	<!-- ##### Please leave this small link back to my site. Thank You! ##### -->
	Valid <a href='http://validator.w3.org/check?uri=referer'>XHTML</a> &amp; <a href='http://jigsaw.w3.org/css-

validator/check/referer'>CSS</a>  Copyright &copy; 2010 </p>
</div>
</body>
</html>
HTML;
		print $html;	
	}
	
	public function showStatusUpdateHTML() {
		print "<form action='" . Constants::WEB_URL . "Main.php' name='form_status' method='POST'>";
	    print "<table align='center' width='650' height='100'><tr><td>";
	    print "<table border=0>";
	    print "<textarea name=status rows=2 cols=80></textarea>";
	    print "</table></td></tr><tr><td align=right><input id='comment' type=submit name=cmd value='Update Status'></td></tr></table></form>";	
	}
	
	public function showCommentsUpdateHTML($statusID='', $app=2, $user='') {
		print "<form action='" . Constants::WEB_URL . "Main.php' name='form_$app" . "_$statusID' method='POST'>";
	    print "<table align='center' width='100' height='25'><tr><td>";
	    print "<table bgcolor='#EDEFF4' border=0>";
	    print "<input type='hidden' name='statusID' value='$statusID'/>";
	    print "<input type='hidden' name='app' value='$app'/>";
	    print "<input type='hidden' name='com_user' value='$user'/>";
	    print "<textarea name=comment height=5 rows=1 cols=60></textarea>";
	    print "</table></td></tr><tr><td align=right>";
	    print "<input id='comment' type=submit name=cmdComment value='Comment' width='100' height ='25' ></td></tr></table></form>";
	}
	
	public function threadResults($oneSocialResponse) {
		
		$finalResponse = array();
		foreach ($oneSocialResponse as $key => $response) {
			$found = false;
			foreach ($oneSocialResponse as $ikey => $iresponse) {
				if ($key != $ikey && $response['0']['text'] == $iresponse['0']['text']) {
					$found = true;
					break;
				}
			}
			if ($found == true ) {
				if ($key < $ikey) {
					$finalResponse[$key] = $response;
					if (isset($iresponse['0']['message'])) {
						foreach ($iresponse['0']['message'] as $msg) {
							$finalResponse[$key]['0']['message'][] = $msg;
						}
					}	
				}
			} else {
				$finalResponse[$key] = $response;	
			}
		}
		
		return $finalResponse;
	}
	
	public function displayUpdates($finalResponse, $recentMsg='', $xml=0) {

		if ($xml) {
			header('Content-type: application/xml');
		}
		
		$keys = array_keys($finalResponse);
		sort($keys, SORT_NUMERIC);

		$oneSocialResponse = self::threadResults($finalResponse);
		
		if ($xml) {
			print "<?xml version='1.0'?>";
			print "<OneSocial>";
		} else {
			print "<table align='center' width='800' height='100'>";
			print "<tr><td><h1>Statuses</h1></td><td width='100'/><td></td></tr><tr><td>";
	    	print "<table border=0>";
		}
		if ($recentMsg) {
	    	print $recentMsg;
	    	self::showCommentsUpdateHTML();
	    }
	    
		foreach ($keys as $key) {
			
			if (!isset($oneSocialResponse[$key])) {
				continue;
			}
			
			foreach ($oneSocialResponse[$key] as $oneResponse) {
				if ($xml) {
					print "<message>";
					if (isset($oneResponse['id'])) {
						print "<id><![CDATA[{$oneResponse['id']}]]></id>";
					}
					print "<image><![CDATA[{$oneResponse['image']}]]></image>";
					print "<user><![CDATA[{$oneResponse['user']}]]></user>";
					print "<text><![CDATA[{$oneResponse['text']}]]></text>";
					if ($oneResponse['app'] == Constants::FACEBOOK_APP_ID) {
						print "<app>Facebook</app>";
					} else {
						print "<app>Twitter</app>";
					}
				} else {
					print "<tr><td valign='top'><img height='50px' width='50px' align='top' src='" . $oneResponse['image'] . "'/></td>";
		    		print "<td colspan='2' valign='top'><b>" . $oneResponse['user'] . "</b>&nbsp;&nbsp;" . $oneResponse['text'] . "<br/>";
				}
				
				if (!$xml) {
	    			self::displayIcon($oneResponse['app']);
				}
	    		if (is_array($oneResponse['time'])) {
					if ($xml) {
						print "<time><![CDATA[" . $oneResponse['time'][Constants::UNIT_VALUE] . ' ' . $oneResponse['time'][Constants::TIME_UNIT] . " ago]]></time>";
					} else {
						print $oneResponse['time'][Constants::UNIT_VALUE] . ' ' . $oneResponse['time'][Constants::TIME_UNIT] . " ago ";	
					}
	    		}
	    		
				if (!empty($oneResponse['attribution'])) {
					if ($xml) {
						print "<attribution><![CDATA[{$oneResponse['attribution']}]]></attribution>";
					} else {
		    			print " via {$oneResponse['attribution']}";
					}
		    	}
		    	
		    	if (!empty($oneResponse['likes'])) {
		    		if ($xml) {
						print "<likes>{$oneResponse['likes']}</likes>";
					} else {
		    			print "<br/>{$oneResponse['likes']} people like this";
					}
		    		
		    	}
		    	
		    	if (!$xml) print "<br/>&nbsp;</td></tr>";
					    				    		
	    		if (isset($oneResponse['message'])) {
		    		foreach ($oneResponse['message'] as $comments) {
		    			
		    			if ($xml) {
		    				print "<comments>";
		    				print "<image><![CDATA[{$comments['image']}]]></image>";
		    				print "<user><![CDATA[{$comments['user']}]]></user>";
		    				print "<text><![CDATA[{$comments['text']}]]></text>";
		    				if ($oneResponse['app'] == Constants::FACEBOOK_APP_ID) {
								print "<app>Facebook</app>";
							} else {
								print "<app>Twitter</app>";
							}
		    			} else {
			    			print "<tr><td>&nbsp;</td><td class='comment' valign='top'><img height='50px' width='50px' align='top' src='" . $comments['image'] . "'/></td>";
					    	print "<td class='comment' valign='top'><b>" . $comments['user'] . "</b>&nbsp;&nbsp;" . $comments['text'] . "<br/>";
		    			}

				    	if (!$xml) {
			    			self::displayIcon($comments['app']);
						}
				    	if (!empty($comments['time'])) {
				    		if ($xml) {
								print "<time><![CDATA[" . $comments['time'][Constants::UNIT_VALUE] . ' ' . $comments['time'][Constants::TIME_UNIT] . " ago]]></time>";
							} else {
								print $comments['time'][Constants::UNIT_VALUE] . ' ' . $comments['time'][Constants::TIME_UNIT] . " ago </td></tr>";	
							}
				    	}
				    	
				    	if ($xml) {
				    		print "</comments>";
				    	}
		    		}
	    		}
			}

			if ($xml) {
				print "</message>";
			} else {
				print '<tr><td colspan="3" valign="top">';
	     		self::showCommentsUpdateHTML($oneResponse['id'], $oneResponse['app'], $oneResponse['user']);
	     		print '</td></tr>';
				print '<tr><td colspan="3" valign="top"><hr size="1" align="left" width="100%"/></td></tr>';	  
			}  	
		}
		
		if ($xml) {
			print "</OneSocial>";	
		} else {
			print "</table></td><td width='100'/></table>";	
		}
	}
	
	public function displayIcon($appID) {
		if ($appID == Constants::TWITTER_APP_ID) {
			print "<img src='images/twitter-icon.png'/>&nbsp;";
		} else {
			print "<img src='images/facebook-icon.png'/>&nbsp;";
		}
	}
	
	protected function determineTimeAgo($userts) {

		$systemts = microtime(true);

        //check to make sure right...
        if(!is_numeric($systemts) || !is_numeric($userts)) {
            return false;
        }

        $time_diff = ($systemts - $userts);
        $unit = '';
        $value = '';

        // Do not show negative or 0 seconds ago
        if ($time_diff < 0) {
            return false;
        }

        if($time_diff < 60){
            $seconds = floor($time_diff);
            $unit = Constants::SECONDS;
            $value = $seconds;
        }
        else if ($time_diff < (60 * 60)) {
            $minutes = floor($time_diff / 60);
            $unit = Constants::MINUTES;
            $value = $minutes;
        }
        else if ($time_diff < (60 * 60 * 24)) {
            $hours = floor($time_diff / (60 * 60));
            $unit = Constants::HOURS;
            $value = $hours;
        }
        else if ($time_diff < (60 * 60 * 24 * 7)) {
            $days = floor($time_diff / (60 * 60 * 24));
            $unit = Constants::DAYS;
            $value = $days;
        }
        else if ($time_diff <= (60 * 60 * 24 * 30.42)) {
            //30.42 is the average days in a month
            $weeks = floor($time_diff / (60 * 60 * 24 * 7));
            $unit = Constants::WEEKS;
            $value = $weeks;
        }
        else if ($time_diff <= (60 * 60 * 24 * 30.42 * 12)) {
            //30.42 is the average days in a month
            $months = floor($time_diff / (60 * 60 * 24 * 30.42));
            $unit = Constants::MONTHS;
            $value = $months;
        }
        else {
            $years = floor($time_diff / (60 * 60 * 24 * 365.25));
            $unit = Constants::YEARS;
            $value = $years;
        }

        if(empty($unit)) {
            return false;
        }

        $out = array();
        $out[Constants::TIME_UNIT]  = $unit;
        $out[Constants::UNIT_VALUE] = $value;
        $out[Constants::SECONDS]    = $time_diff;
        return $out;
    }
}

?>